<template lang="pug">
div
  v-app-bar(color="black" dark absolute)
    v-toolbar-title ArduinoPusher
    v-spacer
    v-btn(icon @click="generateArduino()")
      v-icon mdi-arrow-right-circle
  div#blockly
    div#blocklyArea(style="height:97vh;width:100%;")
    div#blocklyDiv(style="position: absolute;")
</template>
<script>
// const jsons = ["toolbox_standard"]
// const toolbox = []
// for (var i = 0; i < jsons.length; i++) {
//   file = require(`./assets/toolbox/${jsons[i]}.json`)
//   toolbox.push(file)
// }
// const toolbox
export default {
  async asyncData({ $http }) {
    const toolbox = await $http.$get('toolbox.xml')
    return { toolbox }
  },
  components: {
  },
  head: {
    script: [
      {
        src: '/@blockly/blockly_compressed.js', body: true, defer: true
      },
      {
        src: '/@blockly/arduino_compressed.js', body: true, defer: true
      },
      {
        src: '/@blockly/blocks_compressed.js', body: true, defer: true
      },
      {
        src: '/@blockly/msg/js/fr.js', body: true, defer: true
      }
    ]
  },
  data () {
    return {
      workspace: null,
      blockly: null,
    }
  },
  mounted () {
    const $this = this
    setTimeout(function () {
      $this.initBlockly()
      // $this.generateArduino()
    }, 500)
  },
  methods: {
    initBlockly () {
      const $this = this
      this.blockly = window.Blockly
      const blocklyArea = document.getElementById('blocklyArea');
      const blocklyDiv = document.getElementById('blocklyDiv');
      console.log(this.blockly, blocklyArea, blocklyDiv)
      this.workspace = this.blockly.inject(blocklyDiv, {toolbox: this.toolbox});

      var onresize = function(e) {
        var element = blocklyArea;
        var x = 0;
        var y = 0;
        do {
          x += element.offsetLeft;
          y += element.offsetTop;
          element = element.offsetParent;
        } while (element);
        // Position blocklyDiv over blocklyArea.
        blocklyDiv.style.left = x + 'px';
        blocklyDiv.style.top = y + 'px';
        blocklyDiv.style.width = blocklyArea.offsetWidth + 'px';
        blocklyDiv.style.height = blocklyArea.offsetHeight + 'px';
        $this.blockly.svgResize($this.workspace);
      };
      window.addEventListener('resize', onresize, false);
      onresize();
      this.blockly.svgResize(this.workspace);
    },
    generateArduino () {
      const res = this.blockly.Arduino.workspaceToCode(this.workspace);
      console.log(res)
      return res
    }
  }
}
</script>
<style scoped>
#blockly {
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  padding-top: 56px;
}
</style>
